//
//  YKifController.m
//  Shogiban2
//
//  Created by KOYAMA Yoshiaki on Sun Aug 10 2003.
//  Copyright (c) 2003 KOYAMA Yoshiaki. All rights reserved.
//

#import "YKifController.h"
#import "Adapter.h"
#import "InspectorWindowController.h"
#import "BoardManager.h"
#import "ShogibanWindowController.h"
#import "BoardCell.h"
#import "BoardCellKoma.h"
#import "BoardView.h"
#import "XKifController.h"

@implementation YKifController

- (id)init {
    self = [super init];

    _kifArray = [[NSMutableArray alloc] init];
    _kifData = [[NSMutableDictionary alloc] init];
    _indexKif = 0;
    _teaiwari = nil;
    _path = nil;
    _date = nil;
    _senteName = nil;
    _goteName = nil;

    return self;
}

- (NSString *)gameSenteName {
    return _senteName;
}

- (NSString *)gameGoteName {
    return _goteName;
}

- (NSString *)gameDate {
    return _date;
}

// VK̊쐬B
- (void)newKif {

//    [_boardWindow makeKeyAndOrderFront:self];
    [NSApp beginSheet:_newWindow 
        modalForWindow:_boardWindow 
        modalDelegate:self
        didEndSelector:@selector(sheetDidEnd:returnCode:contextInfo:)
        contextInfo:nil];        
}

- (IBAction)endNewYes:(id)sender {
    [_newWindow orderOut:sender];
    [NSApp endSheet:_newWindow returnCode:1];
}

- (IBAction)endNewNo:(id)sender {
    [_newWindow orderOut:sender];
    [NSApp endSheet:_newWindow returnCode:2];
}

- (void)sheetDidEnd:(NSWindow *)sheet 
            returnCode:(int)returnCode
            contextInfo:(void *)contextInfo {

    if (returnCode == 1) {
//        [self initKifController];
        _senteName = [[_newSenteTextField stringValue] retain];
        _goteName = [[_newGoteTextField stringValue] retain];
        _teaiwari = [NSNumber numberWithInt:([_newTeaiwari indexOfSelectedItem] + 1)];
        [_teaiwari retain];
        _date = [[[NSDate date] description] retain];

        [_boardManager initBoardManager:[_teaiwari intValue]];
//        [_boardView setEditFlag:YES];

        [_boardView setEditFlag:YES];
        [_boardView setNeedsDisplay:YES];
        [_shogibanWindowController setDocumentEdited:YES];
        [[_shogibanWindowController document] updateChangeCount:NSChangeDone];

        [[NSNotificationCenter defaultCenter] postNotificationName:SBInspectorChangeNotification object:self];
    } else {
        [_boardWindow performClose:self];
    }
}

- (void)awakeFromNib {

    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(selectedRotateStepChange:) name:SBRotateStepChangeNotification object:[InspectorWindowController sharedInspectorController]];

    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(selectedFrontStepChange:) name:SBFrontStepChangeNotification object:[InspectorWindowController sharedInspectorController]];

    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(selectedBackStepChange:) name:SBBackStepChangeNotification object:[InspectorWindowController sharedInspectorController]];

    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(selectedFrontStep2Change:) name:SBFrontStep2ChangeNotification object:[InspectorWindowController sharedInspectorController]];

    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(selectedBackStep2Change:) name:SBBackStep2ChangeNotification object:[InspectorWindowController sharedInspectorController]];

    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(mainWindowChanged:) name:NSWindowDidBecomeMainNotification object:nil];

}

- (void)mainWindowChanged:(NSNotification *)notification {
    ShogibanWindowController *controller = [[notification object] windowController];

    if (controller && [controller isKindOfClass:[ShogibanWindowController class]]) {
        if ([_boardWindow isMainWindow] == YES) { 
//            [[NSNotificationCenter defaultCenter] postNotificationName:SBInspectorChangeNotification object:self];
        }
    }
}

- (void)selectedRotateStepChange:(NSNotification *)notification {
 
    if ([_boardWindow isMainWindow] == YES) { 
        [_adapter rotate];
        [_boardView setNeedsDisplay:YES];
    }
}

- (void)selectedFrontStepChange:(NSNotification *)notification {
 
    if ([_boardWindow isMainWindow] == YES) { 
        [self doFrontStepKif];
        [_boardView setNeedsDisplay:YES];
    }
}

- (void)selectedBackStepChange:(NSNotification *)notification {
 
    if ([_boardWindow isMainWindow] == YES) { 
        [self doBackStepKif];
        [_boardView setNeedsDisplay:YES];
    }
}

- (void)selectedFrontStep2Change:(NSNotification *)notification {
 
    if ([_boardWindow isMainWindow] == YES) { 
        while (_indexKif < [_kifArray count]) {
            [self doFrontStepKif];
            [_boardView setNeedsDisplay:YES];
        }
    }
}

- (void)selectedBackStep2Change:(NSNotification *)notification {
 
    if ([_boardWindow isMainWindow] == YES) { 
        while (_indexKif > 0) { 
            [self doBackStepKif];
        [_boardView setNeedsDisplay:YES];
        }
    }
}

// iޏB
- (void)doFrontStepKif {
    BoardCell *selectSrc, *selectDest, *placeSrc, *placeDest;
    
    if (_indexKif >= [_kifArray count]) {
        return;
    }

    selectSrc = [_kifArray objectAtIndex:_indexKif];
    selectDest = [_kifArray objectAtIndex:_indexKif+1];
    placeSrc = [_kifArray objectAtIndex:_indexKif+2];
    placeDest = [_kifArray objectAtIndex:_indexKif+3];

    _indexKif += 4;

   [_boardManager frontStepKif:selectSrc :selectDest
    :placeSrc :placeDest];

    [[NSNotificationCenter defaultCenter] postNotificationName:SBInspectorChangeNotification object:self];
}

// ߂B
- (void)doBackStepKif {
    BoardCell *selectSrc, *selectDest, *placeSrc, *placeDest;
    BoardCell *selectSrc1, *selectDest1, *placeSrc1, *placeDest1;
    
    if (_indexKif <= 0) {
        return;
    } 
    
    selectSrc = [_kifArray objectAtIndex:_indexKif-4];
    selectDest = [_kifArray objectAtIndex:_indexKif-3];
    placeSrc = [_kifArray objectAtIndex:_indexKif-2];
    placeDest = [_kifArray objectAtIndex:_indexKif-1];

    if (_indexKif >= 8) {
        selectSrc1 = [_kifArray objectAtIndex:_indexKif-8];
        selectDest1 = [_kifArray objectAtIndex:_indexKif-7];
        placeSrc1 = [_kifArray objectAtIndex:_indexKif-6];
        placeDest1 = [_kifArray objectAtIndex:_indexKif-5];
    } else {
        selectSrc1 = nil;
        selectDest1 = nil;
        placeSrc1 = nil;
        placeDest1 = nil;
    }

    _indexKif -= 4;

   [_boardManager backStepKif:selectSrc :selectDest
    :placeSrc :placeDest :selectSrc1 :selectDest1
    :placeSrc1 :placeDest1];

   if ([_boardView editFlag] == YES) {
        [self removeKifController];
    }

    [[NSNotificationCenter defaultCenter] postNotificationName:SBInspectorChangeNotification object:self];

}

- (void)doOpen:(NSData *)data :(NSString *)type {

/*
    _kifArray = [[NSMutableArray alloc] init];
    _kifData = [[NSMutableDictionary alloc] init];
    _teaiwari = nil;
    _path = nil;
    _date = nil;
    _senteName = nil;
    _goteName = nil;

//   [self initKifController];
*/
    [_kifArray release];
    [_kifData release];

    _indexKif = 0;

    // xshogi̊ǂݍ܂ꂽꍇB
    if ([type isEqualToString:FILE_XEXT] == YES) {

        [_xkifController initBoardController:TEAI_HIRATE];
        _kifArray = [[NSMutableArray alloc] init];

	[_xkifController contentOfData:data];
        [_xkifController loadKif];
        _indexKif = 0;

        _teaiwari = [[NSNumber numberWithInt:TEAI_HIRATE] retain];

        _senteName = [_xkifController senteName];
        [_senteName retain];
        _goteName = [_xkifController goteName];
        [_goteName retain];

        _date = [_xkifController date];

        [_boardManager initBoardManager:[_teaiwari intValue]];
        [_boardView setEditFlag:NO];

        [_boardView setNeedsDisplay:YES];

    // ʏ̊ǂݍ܂ꂽꍇB
    } else if ([type isEqualToString:FILE_EXT] == YES) {

        _kifData = [[NSUnarchiver unarchiveObjectWithData:data] retain];

        _teaiwari = [[_kifData objectForKey:@"Teaiwari"] retain];
        _senteName = [[_kifData objectForKey:@"Sente"] retain];
        _goteName = [[_kifData objectForKey:@"Gote"] retain];
        _date = [[_kifData objectForKey:@"Date"] retain];

//        [self printTaikyoku];
        _kifArray = [[_kifData objectForKey:@"Kif"] retain];
        [_boardManager initBoardManager:[_teaiwari intValue]];

//        [_boardView setEditFlag:NO];
//        [_controlPanel setTitle:[[_path stringByDeletingPathExtension] 
//        lastPathComponent]];
//        [self printTesuu];

        [_boardView setNeedsDisplay:YES];
    }
}

- (int)startKomaKind {
    BoardCell *cell;
    int komaKind;

    if ([_kifArray count] == 0)
        return 0;

    cell = [_kifArray objectAtIndex:0];
    komaKind = [cell boardCellKomaKind];
    return komaKind;
}

// ɒǉB
- (void)addKifController:(BoardCell *)selectSource :(BoardCell *)selectDestination
    :(BoardCell *)placeSource :(BoardCell *)placeDestination {
    [_kifArray addObject:[[BoardCell alloc] initBoardCell:selectSource]];
    [_kifArray addObject:[[BoardCell alloc] initBoardCell:selectDestination]];
    [_kifArray addObject:[[BoardCell alloc] initBoardCell:placeSource]];
    [_kifArray addObject:[[BoardCell alloc] initBoardCell:placeDestination]];
    _indexKif += 4;

    [[NSNotificationCenter defaultCenter] postNotificationName:SBInspectorChangeNotification object:self];

}

// ߂B
- (void)removeKifController {
    [_kifArray removeLastObject];    
    [_kifArray removeLastObject];
    [_kifArray removeLastObject];    
    [_kifArray removeLastObject];
}

- (int)indexKif {
    return _indexKif;
}

- (int)kifArrayMax {
    return [_kifArray count];
}

- (void)dealloc {
    [[NSNotificationCenter defaultCenter] removeObserver:self];
    [super dealloc];
}

// t@CɕۑB
- (NSData *)doSave {
    [_kifData release];
    _kifData = [[NSMutableDictionary alloc] init];
 
    [_kifData setObject:_teaiwari forKey:@"Teaiwari"];
    [_kifData setObject:_senteName forKey:@"Sente"];
    [_kifData setObject:_goteName forKey:@"Gote"];
    [_kifData setObject:_date forKey:@"Date"];
    [_kifData setObject:_kifArray forKey:@"Kif"];

    [_boardView setEditFlag:NO];
    [_shogibanWindowController setDocumentEdited:NO];  

    return [NSArchiver archivedDataWithRootObject:_kifData];
}

// j[̏B
- (BOOL)validateMenuItem:(NSMenuItem *)anItem :(NSString *)type {
    NSString *title;
    BOOL editFlag;

    title = [anItem title];
    editFlag = [_boardView editFlag];

//    NSLog(@"%@", title);
    if ([title isEqualToString:NSLocalizedString(@"NEWITEM",@"")] == YES) {
        return YES;
    } else if ([title isEqualToString:NSLocalizedString(@"CONTINUEITEM",@"")] 
    == YES) {
        if ([type isEqualToString:FILE_XEXT] == YES) {
            return NO;
        }        
 
        if (editFlag == YES) {
            return NO;
        } else if (_senteName == nil) {
            return NO;
        } else {
            return YES;        
        }
    } else if ([title isEqualToString:NSLocalizedString(@"RECONTINUEITEM",@"")] 
    == YES) {	        
        if ([type isEqualToString:FILE_XEXT] == YES) {
            return NO;
        }        
        if (editFlag == YES) {
            return NO;
        } else if (_senteName == nil) {
            return NO;
        } else {
            return YES;
        }
    } else if ([title isEqualToString:NSLocalizedString(@"READITEM",@"")] == YES) {
        return YES;
    } else if ([title isEqualToString:NSLocalizedString(@"SAVEITEM",@"")] == YES) {
        if (editFlag == YES) {
            return YES;
        } else {
            return NO;
        }
    } else if ([title isEqualToString:NSLocalizedString(@"SAVEASITEM",@"")] == YES) {
        if ( editFlag == YES) {
            return YES;
        } else {
            return NO;
        }
    }

    return YES;
}

// p΋ǁB
- (void)editKif {
    int i, index;

    index = [_kifArray count] - _indexKif;

    for (i=0; i<index; i++) {
        [_kifArray removeLastObject];
    }
    [_boardView setEditFlag:YES];
    [_shogibanWindowController setDocumentEdited:YES];  

    [[NSNotificationCenter defaultCenter] postNotificationName:SBInspectorChangeNotification object:self];

}

// fǖʂ̓́B
- (void)editEndKif {
    while (_indexKif < [_kifArray count]) {
        [self doFrontStepKif];
        [_boardView setNeedsDisplay:YES];
    }
    [_boardView setEditFlag:YES];
    [_shogibanWindowController setDocumentEdited:YES];  

    [[NSNotificationCenter defaultCenter] postNotificationName:SBInspectorChangeNotification object:self];
}

- (void)windowDidBecomeMain:(NSNotification *)aNotification {
   if (_senteName == nil) {
        [self newKif];        
    }

    [[NSNotificationCenter defaultCenter] postNotificationName:SBInspectorChangeNotification object:self];
}

// ۂɊ\B
- (void)printKifController {
    int i, count;
    BoardCell *cell;

    count = [_kifArray count];
    for (i=0; i<count; i++) {
        if ((i % 4) == 0) {
            NSLog(@"[%d][%d]------",i,(i/4));        
        }
        cell = [_kifArray objectAtIndex:i];
        [cell printBoardCell];
    }
    NSLog(@"[%d][%d]------",count,(count/4));
}


@end
